package GUI;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.util.Random;

public class Ball {

	private int posX = 100;
	private int posY = 100;
	private int xDirection =  1;
	private int yDirection = 1;
	private static int speed;
	private int radius = 15;
	
	static Random generator = new Random();
	public static Color color;
	private boolean filled = true;

	public Ball(Point point)
	{
		posX = point.x;
		posY = point.y;
		color = new Color(Math.abs(generator.nextInt())% 16777216);
	}
	
	public void move()      
	{         
		posX = posX + speed*xDirection;         
		posY = posY + speed*yDirection;      
	}
	
    public int getXDirection() {
		return xDirection;
	}

	public void setXDirection(int direction) {
		xDirection = direction;
	}

	public int getYDirection() {
		return yDirection;
	}

	public void setYDirection(int direction) {
		yDirection = direction;
	}
	
	public void draw(Graphics g)
	{         
		Color oldColor = g.getColor();         
		g.setColor(color);      
		// Translates circle's center to rectangle's origin for drawing.         
		if (filled)
		{
			g.fillOval(posX - radius, posY - radius, radius * 2, radius * 2);
		}
			         
		else
		{
			g.drawOval(posX - radius, posY - radius, radius * 2, radius * 2);
		}
			         
		g.setColor(oldColor);      
		
	}
	
	public int getRadius() {
		return radius;
	}

	public void setRadius(int radius) {
		this.radius = radius;
	}

	public static int getSpeed() {
		return speed;
	}
	public static void setSpeed(int newSpeed) {
		speed = newSpeed;
	}

	public int getPosX() {
		return posX;
	}

	public void setPosX(int posX) {
		this.posX = posX;
	}

	public int getPosY() {
		return posY;
	}

	public void setPosY(int posY) {
		this.posY = posY;
	}
}
