package GUI;

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.util.Hashtable;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class Frame extends JFrame{
	
	private Container thisContent;
	public static JButton closeButton, startButton,stopButton;
	public static JButton colorButton;
	public static JTextArea eventField;
	public static JSlider slider;
	private JLabel logLabel,testlabel,bounceLabel,colorLabel;
	private JCheckBox checkBox;
	private JScrollPane eventScroll;
	public static JTextField textField,colorField;
	private JPanel panel;
	public static int counter = 0;
	public static boolean pause = true;
	public static boolean frozen;
	private boolean started = false;
	
	private int minval = 0;
	private int maxval = 50;
	private int startingval = 3;
	private String text ="";

	Ball ball;

	
	private class Event implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
            Object source = e.getSource();
            
            if(source == closeButton)
            {
            	System.exit(0);
            }
            if(source == stopButton)
            {
            	/*savedSpeed = ball.getSpeed();*/
            	/*BallPanel.timerStop();*/
            	if(started)
            	{
            		if(frozen)
                	{
            			slider.setEnabled(true);
                		BallPanel.timer.start();
                		stopButton.setText("Stop");
                	}
                	else
                	{
                		slider.setEnabled(false);
                		BallPanel.timer.stop();
                		stopButton.setText("Continue");
                	}
                	frozen = !frozen;
                	
                	text = eventField.getText();
                	eventField.setText(text + "***** NEW EVENT *****\n" +
                			"Stopbutton has been clicked.\n" +
                			"An ActionListener has been\n notified\n");
            	}
            	
            }
            if(source == startButton)
            {
            	BallPanel.timer.start();
            	started = true;
            	frozen = false;
            	slider.setEnabled(true);
            }
            if(source == checkBox)
            {
            	text = eventField.getText();
            	eventField.setText(text + "***** NEW EVENT *****\n" +
            			"Checkbox has been checked.\n" +
            			"An ActionListener and Change-\nListener has been notified\n");
            	
            }
            if(source == colorButton)
            {
            	try
            	{
            		int colour;
            		colour = Math.abs(Integer.parseInt(colorField.getText())% 16777216);
            		
            		
            		Ball.color = new Color(colour);
            	}
            	catch(NumberFormatException excep)
            	{
            		System.out.println("NFE: "+excep);
            	}
	        	if(!frozen && started)
	        	{
	        		text = eventField.getText();
	            	eventField.setText(text + "***** NEW EVENT *****\n" +
	            			"Colourbutton has been clicked.\n" +
	            			"An ActionListener has been\n notified\n");
	        		if(pause)
	        		{
	        			Frame.slider.setEnabled(false);
	        			BallPanel.timer.stop();
		        		stopButton.setText("Continue");
		        		frozen = true;
	        		}
	        		
	        	}
            	 
            }
        }
    }
	private class ItemStateChanged implements ItemListener
	{		
		public void itemStateChanged(ItemEvent e)
        {
           Object source = e.getItemSelectable();

           if (source == checkBox) 
           {
               pause = !pause;
           }
        }
	}
	
	private class StateChanged implements ChangeListener
	{
		
	    public void stateChanged(ChangeEvent e) {
	        JSlider source = (JSlider)e.getSource();
	        
	        if (!source.getValueIsAdjusting()) {
	        	
	        	if(!frozen && started)
	        	{
		        	int value = source.getValue();
		        	testlabel.setText("The value "+value);
		          	
		        	text = eventField.getText();
		        	eventField.setText(text + "***** NEW EVENT *****\n" +
	          			"Slider has been moved.\n" +
	          			"A ChangeListener has been \nnotified\n");
		        	Ball.setSpeed(value);
	        	
		        	if(pause)
		        	{
		        		BallPanel.timer.stop();
		        		stopButton.setText("Continue");
		        		frozen = true;
		        	}
	        		
	        	}
	        }
	    }
	}
	
	public Frame()
	{	
		
		thisContent = getContentPane();
		thisContent.setLayout(null);
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension skaerm = toolkit.getScreenSize();

		int hoejde = (int)skaerm.getHeight();
		int bre = (int)skaerm.getWidth();
		int xpos = (bre-600)/2;
		int ypos = (hoejde-400)/2;

		setBounds(xpos,ypos,600,400);
		setTitle("Java GUI for DM8xx");
		setResizable(false);
		
		// Buttons
		
		closeButton = new JButton("Exit");
		closeButton.setBounds(450, 325, 120, 20);
		closeButton.addActionListener(new Event());
		
		startButton = new JButton("Start");
		startButton.setBounds(25, 325, 120, 20);
		startButton.addActionListener(new Event());
		
		stopButton = new JButton("Stop");
		stopButton.setBounds(145, 325, 120, 20);
		stopButton.addActionListener(new Event());
		
		colorButton = new JButton("Set color");
		colorButton.setBounds(100,85,85,20);
		colorButton.addActionListener(new Event());
		
		//TextFields
		
		textField = new JTextField(""+counter);
		textField.setBounds(100,25,85,20);
		textField.setEditable(false);
		
		colorField = new JTextField();
		colorField.setBounds(100,65,85,20);
		
		// Textareas
		
		eventField = new JTextArea();
//		eventField.setBounds(175,25,170,280);
		eventField.setLineWrap(true);
		eventField.setEditable(false);
		
		eventScroll = new JScrollPane(eventField);
		eventScroll.setBounds(190,25,200,280);
		
		// Labels
		
		bounceLabel = new JLabel("Bounces");
		bounceLabel.setBounds(100,10,60,15);
		
	    logLabel = new JLabel("Log");
	    logLabel.setBounds(190,10,100,15);
	    
	    testlabel = new JLabel("Test ");
	    testlabel.setBounds(100,200,100,100);
	    
	    colorLabel = new JLabel("Color nr:");
	    colorLabel.setBounds(100,50,60,15);
	   
	    // Checkbox
	    
	    checkBox = new JCheckBox("Pause on event");
	    checkBox.setMnemonic(KeyEvent.VK_P);
	    checkBox.setBounds(280, 325, 115, 20);
	    checkBox.setSelected(true);
	    checkBox.addItemListener(new ItemStateChanged());
	    checkBox.addActionListener(new Event());
	    
	    //Sliders
	    
	    slider = new JSlider(JSlider.VERTICAL,
               minval, maxval, startingval);
	     
	    slider.setBounds(0, 10, 100, 280);
	     
	    //Create the label table
	 /*   Hashtable<Integer,JLabel> labelTable = new Hashtable<Integer,JLabel>();
	    labelTable.put( new Integer( 0 ), new JLabel("Speed (0)") );
	    labelTable.put( new Integer( minval+1 ), new JLabel("Slow (1)") );
	    labelTable.put( new Integer( maxval ), new JLabel("Fast (5)") );
	    slider.setLabelTable( labelTable );
	    slider.setPaintTicks(true);*/
	    
	    slider.setMajorTickSpacing(10);
	    slider.setPaintLabels(true);
	    slider.addChangeListener(new StateChanged());
	    slider.setEnabled(false);

	     //Panel
	     
	    panel = new JPanel();
	    panel.setBounds(400,25,172,280);
	    panel.setLayout(null);
	    panel.setBorder(new EtchedBorder());
	    
	    BallPanel bpanel = new BallPanel(172,280);
	    bpanel.setBounds(400,25,172,280);
	    bpanel.setBorder(new EtchedBorder());
	    
	    BallPanel.timer.stop();
	    
		//Adding of elements to the Container
		
	    //Buttons
		thisContent.add(closeButton);
		thisContent.add(startButton);
		thisContent.add(stopButton);
		thisContent.add(colorButton);
		//TextField
		thisContent.add(textField);
		thisContent.add(colorField);
		//Textarea
		thisContent.add(eventScroll);
		//Labels
		thisContent.add(colorLabel);
		thisContent.add(logLabel);
		thisContent.add(bounceLabel);
		//thisContent.add(testlabel);
		//Checkboxes
		thisContent.add(checkBox);
		//sliders
		thisContent.add(slider);
		//panels
		thisContent.add(panel);
		//The ballpanel
		thisContent.add(bpanel);
		
		setDefaultCloseOperation(EXIT_ON_CLOSE);
	}
}
